#include <iostream>

#include "index.h"
#include "parameters.h"

using namespace std;
using namespace cvflannIndex;


int main(int argc, char *argv[])
{
    for (int i=0; i<100;i++) {
        string clusterFile = "/home/gorkem/code/data/all_noGames.cluster_50K_100i_F.hdf5";
        string indexFile = "/home/gorkem/code/data/all_noGames.cluster_50K_100i_F.hdf5.index.hdf5";
        typedef unsigned char FT; //featureType
        typedef float CT; //clusterType
        cvflannIndex::Index<FT,CT> *index = new cvflannIndex::Index<FT,CT>();
        index->loadClusters(clusterFile);
//        index->loadClusterIndex(indexFile);
        delete index;
        index = NULL;
    }
    return 0;


	typedef unsigned char featType;
	typedef float clusType;




/*
    getParameters(argc, argv);
    Mat data;
    loadTxt<clusType>(data,INPUT_FILE1);
    save<clusType>(data,INPUT_FILE2);
    exit(0);
*/



/*
	Mat a(3,4,CV_32S);
	a.at<int>(0,0)=9;
	cout<<"a:"<<endl<<a<<endl;

	int *d=new int[16];
{
	Mat b(4,4,CV_32S,d);
	cout<<"b:"<<endl<<b<<endl;


	a = b;
	cout<<"a:"<<endl<<a<<endl;
	cout<<"b:"<<endl<<b<<endl;


	b.at<int>(1,1) = 13;
	cout<<"b:"<<endl<<b<<endl;
	b.release();
	b.deallocate();
}
	cout<<"a:"<<endl<<a<<endl;
	return 0;
*/


/*
    getParameters(argc, argv);

	Mat test1;
	Mat test2;
//	load<featType>(test,"/home/gorkem/code/data/filliat-all.mkey.hdf5");
//	save<featType>(test,"/home/gorkem/code/data/filliat-all.mkey2.hdf5");

	test1 = loadTxt<featType>(INPUT_FILE1);
	load<featType>(test2,INPUT_FILE2);


	cout<<"comparing two matrices"<<endl;
	if(test1.cols!=test2.cols || test1.rows!=test2.rows) {
		cout<<"dimensions do not match"<<endl;
	}
	else {
		size_t rows = test1.rows;
		size_t cols = test1.cols;
		for(size_t i = 0; i<rows; i++) {
			for(size_t j = 0; j<cols; j++) {
				if(test1.at<featType>(i,j)!=test2.at<featType>(i,j)) {
					cout<<"MISMATCH"<<endl;
				}
			}
		}
		cout<<"They are the same"<<endl;
	}
	return 0;
*/
/*
	if(test1.isContinuous()) {
		cout<<"Raw cont.."<<endl;
	}
	else
		cout<<"Raw NOT cont..."<<endl;
*/
/*
	if(test2.isContinuous()) {
		cout<<"HDF5 cont.."<<endl;
	}
	else
		cout<<"HDF5 NOT cont..."<<endl;
*/
/*
    Mat data(20006481,128,(size_t)flann::CvType<featType>().type());
	if(data.isContinuous()) {
		cout<<"data cont.."<<endl;
	}
	else
		cout<<"data NOT cont..."<<endl;
*/
/*
	size_t inc = 100000;
	size_t cols = 128;
	for(size_t rows=1000000; rows<50000000; rows=rows+inc) {
		featType *rawData = new featType[rows * cols];

		Mat data(rows,128,(size_t)flann::CvType<featType>().type(),rawData);
		cout<<"Matrix with "<<rows/1000<<"K rows and "<<cols<<" cols is ";
		if(data.isContinuous()) 
			cout<<"cont.."<<endl;
		else
			cout<<"NOT cont..."<<endl;

		delete rawData;
	}


//	saveTxt<featType>(test1,"raw.txt");
//	saveTxt<featType>(test2,"hdf5.txt");

	return 0;

//	saveTxt<featType>(test,"/home/gorkem/code/data/filliat-all.mkey2");
//	save<featType>(test,"/home/gorkem/code/data/filliat-all.mkey2.hdf5");
*/


/*
	double v = 16;
	unsigned char c = (unsigned char)v;

	if (c==16)
		cout<<"a: "<<atoi((const char*)&c)<<endl;
	else
		cout<<"b: "<<c<<endl;
*/

//return 0;

/*
   printf("Size short %ld\n",sizeof(short));
   printf("Size %ld\n",sizeof(unsigned char));
  */  
  /*  void * p = malloc(atoi(argv[1]));
    if ( p == NULL )
      printf("Error 1\n");
    p=malloc(atoi(argv[1]));
    if ( p == NULL )
      printf("Error 2\n");
    p= malloc(atoi(argv[1]));
    if(p == NULL )
      printf("Error  3\n");
    else
      printf("ok\n");

    printf("%d Size of char %ld\n",CHAR_BIT,sizeof(size_t));

    return 0;
  */


    Index<featType,clusType> idx;
    //idx.test();
    //return 0;

    //idx.extractFeatures("/home/gorkem/datasets/temp/");
    //return 0;

    //idx.test();
    //return 0;

    //idx.loadClusters("/home/gorkem/code/data/cluster_permis10K_double.hdf5");
    //idx.buildClusterIndex();
    //idx.saveClusterIndex("index_temp.hdf5");
    //idx.loadClusterIndex("/home/gorkem/code/data/index_permis10K_double.hdf5");
    //return 0;

    // -- Load parameters, help
        getParameters(argc, argv);
    if (params.count("help")) {
        print_usage();
        return EXIT_FAILURE;
    }

    if (COUNT_LINES) {
        int numLines = countLines(INPUT_FILE1);
        cout << INPUT_FILE1 << " contains " << numLines << " rows" << endl;
        return EXIT_SUCCESS;
    }

    if (CONCAT_FILES) {
        concatFiles(INPUT_FILE1,INPUT_FILE2,OUTPUT_FILE);
        return EXIT_SUCCESS;
    }

    if (EXTRACT_FEATURES) {
        idx.extractFeatures(DIRECTORY);
        return EXIT_SUCCESS;
    }

    if (MERGE_FEATURES) {
        if (!idx.mergeFeatureFiles(DIRECTORY,FEATURE_FILE,true))
            return EXIT_FAILURE;
        return EXIT_SUCCESS;
    }

    if (QUERY_IMAGE) {
        if(CLUSTER_FILE != "") {
            idx.loadClusters(CLUSTER_FILE);
        }
        if(INDEX_FILE != "") {
            idx.loadClusterIndex(INDEX_FILE);
        }
        if (!idx.queryImage(IMAGE_FILE))
            return EXIT_FAILURE;
        return EXIT_SUCCESS;
    }

    if (CONVERT_TO_HDF5) {
        if (!convertToHDF5<featType>(*idx.getFeatures(),FEATURE_FILE))
            return EXIT_FAILURE;
        return EXIT_SUCCESS;
    }

    if (BUILD_CLUSTERS) {
        if(FEATURE_FILE == "") {
            return EXIT_FAILURE;
        }
        idx.loadFeatures(FEATURE_FILE);

        if (!idx.buildClusters(NUM_CLUSTERS, NUM_ITER))
            return EXIT_FAILURE;
        string clusterfile = "";
        if(CLUSTER_FILE != "")
            clusterfile = CLUSTER_FILE;
        else
            clusterfile = FEATURE_FILE + ".cluster.hdf5";
        if (!idx.saveClusters(clusterfile))
            return EXIT_FAILURE;
        return EXIT_SUCCESS;
    }

    if (BUILD_CLUSTER_INDEX) {
        if(CLUSTER_FILE != "") {
            idx.loadClusters(CLUSTER_FILE);
        }
        if (!idx.buildClusterIndex())
            return EXIT_FAILURE;
        string indexfile = "";
        if(INDEX_FILE != "")
            indexfile = INDEX_FILE;
        else
            indexfile = CLUSTER_FILE + ".index.hdf5";
        if (!idx.saveClusterIndex(indexfile))
            return EXIT_FAILURE;
        return EXIT_SUCCESS;
    }


    return 1; 
}

