#ifndef PROGRESSBAR_H
#define PROGRESSBAR_H

#include <QtGui>

class ProgressBar : public QProgressBar
{
    Q_OBJECT;
public:
    ProgressBar(QWidget *parent=0) : QProgressBar(parent) {
        setWindowModality(Qt::WindowModal);
        resize(QSize(400,50));
        setSizePolicy(QSizePolicy::Fixed,QSizePolicy::Fixed);
        setRange(0,100);
        setValue(0);
    }

public slots:

private slots:
    void closeEvent(QCloseEvent *event)
    {
        emit dialogClosed();
        event->accept();

        deleteLater(); //or delete this;
    }

signals:
    void dialogClosed();

};

#endif // PROGRESSBAR_H
