#include "vertexinput.h"

VertexInput::VertexInput(QDialog *parent) : QDialog(parent)
{
    setWindowTitle(QString("Vertex:"));

    input = new QLineEdit();
    QIntValidator *ivalidator = new QIntValidator();
    input->setValidator(ivalidator);
    input->setMaximumSize(60,25);
    input->setMaxLength(6);
    input->setCursorPosition(0);
    input->setVisible(true);

    QHBoxLayout *hbox = new QHBoxLayout;
    hbox->addWidget(input);
    setLayout(hbox);

    setFixedSize(QSize(150,50));

    connect(input,SIGNAL(returnPressed()),this,SLOT(accept()));
}
