#include "global.h"
#include "visapp.h"
#include "simmap.h"

VisApp::VisApp(int & argc, char ** argv)
    : QApplication(argc, argv)
{
    mainWindow = new MainWindow();
    setWindowIcon(QIcon(ICON_LOGO));
    mainWindow->setWindowTitle("VisApp - User interface for visual localization and mapping...");
}

VisApp::~VisApp()
{
    // Delete every system temporary file
    char systemcall[200];
    sprintf(systemcall,"rm -rf sys");
    //system(systemcall);
}

int VisApp::run()
{
    mainWindow->show();
    return exec();
    //SimMap a;
    //a.mergeSmartMulti(NULL,NULL,4,(SimMap::MergeStopCriteria)0,0);
}
