#ifndef EDGEINPUT_H
#define EDGEINPUT_H

#include <QDialog>
#include <QtGui>

class EdgeInput : public QDialog
 {
     Q_OBJECT

 public:
    EdgeInput(QDialog *parent = 0);
    int getVertex1Id() {
        if(input1->text().isEmpty())
            return -1;
        else
            return input1->text().toInt();
    }
    int getVertex2Id() {
        if(input2->text().isEmpty())
            return -1;
        else
            return input2->text().toInt();
    }

 private:
    QLineEdit *input1;
    QLineEdit *input2;
 };

#endif // EDGEINPUT_H
