#ifndef EDGEINPUTTEXT_H
#define EDGEINPUTTEXT_H

#include <QDialog>
#include <QtGui>
#include <vector>

using namespace std;

class EdgeInputText : public QDialog
 {
     Q_OBJECT

 public:
    EdgeInputText(QDialog *parent = 0);
    vector<pair<int,int> > limit1() { return getLimits(input1->text()); }
    vector<pair<int,int> > limit2() { return getLimits(input2->text()); }

 private:
    QLineEdit *input1;
    QLineEdit *input2;

    vector<pair<int,int> > getLimits(QString s);
    pair<int,int> splitLimits(QString s);
 };

#endif // EDGEINPUTTEXT_H
